using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using Outlook = Microsoft.Office.Interop.Outlook;
using System.Windows.Forms;

namespace ShowSpecialForm
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("9D859F18-11BD-4C5A-896A-F15197A7E9D6"), ProgId("ShowSpecialForm.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            InitializeComponent();
        }

        private AddinExpress.OL.ADXOlFormsManager adxOlFormsManager1;
        private AddinExpress.OL.ADXOlFormsCollectionItem InboxItem;
        private AddinExpress.OL.ADXOlFormsCollectionItem MailItem;
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxOlFormsManager1 = new AddinExpress.OL.ADXOlFormsManager(this.components);
            this.InboxItem = new AddinExpress.OL.ADXOlFormsCollectionItem(this.components);
            this.MailItem = new AddinExpress.OL.ADXOlFormsCollectionItem(this.components);
            // 
            // adxOlFormsManager1
            // 
            this.adxOlFormsManager1.Items.Add(this.InboxItem);
            this.adxOlFormsManager1.Items.Add(this.MailItem);
            this.adxOlFormsManager1.OnInitialize += new AddinExpress.OL.ADXOlFormsManager.OnComponentInitialize_EventHandler(this.adxOlFormsManager1_OnInitialize);
            this.adxOlFormsManager1.ADXBeforeFolderSwitch += new AddinExpress.OL.ADXOlFormsManager.BeforeFolderSwitch_EventHandler(this.adxOlFormsManager1_ADXBeforeFolderSwitch);
            this.adxOlFormsManager1.SetOwner(this);
            // 
            // InboxItem
            // 
            this.InboxItem.ExplorerLayout = AddinExpress.OL.ADXOlExplorerLayout.RightSubpane;
            this.InboxItem.FormClassName = "ShowSpecialForm.InboxForm";
            // 
            // MailItem
            // 
            this.MailItem.ExplorerItemTypes = AddinExpress.OL.ADXOlExplorerItemTypes.olMailItem;
            this.MailItem.ExplorerLayout = AddinExpress.OL.ADXOlExplorerLayout.BottomSubpane;
            this.MailItem.FormClassName = "ShowSpecialForm.MailForm";
            // 
            // AddinModule
            // 
            this.AddinName = "ShowSpecialForm";
            this.ShimProgID = "ShowSpecialFormShim.Proxy";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;
            this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);

        }
        #endregion
 
        #region ADX automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        private void AddinModule_AddinStartupComplete(object sender, EventArgs e)
        {
        }

        private void adxOlFormsManager1_ADXBeforeFolderSwitch(object explorerObj, AddinExpress.OL.ADXOlFormsCollectionItem SrcItem, object SrcFolder, AddinExpress.OL.ADXOlFormsCollectionItem DstItem, object DstFolder)
        {
        }

        private void adxOlFormsManager1_OnInitialize()
        {
            #region Set special FolderName property for ADXOlFormsCollectionItem

            Outlook.NameSpace NameSpaceObj = null;
            Outlook.MAPIFolder InboxFolderObj = null;
            Outlook.MAPIFolder ParentInboxFolderObj = null;

            try
            {
                NameSpaceObj = OutlookApp.GetNamespace("MAPI");
                if (NameSpaceObj != null)
                {
                    InboxFolderObj = NameSpaceObj.GetDefaultFolder(Microsoft.Office.Interop.Outlook.OlDefaultFolders.olFolderInbox);
                    if (InboxFolderObj != null)
                    {
                        ParentInboxFolderObj = (InboxFolderObj.Parent as Outlook.MAPIFolder);
                        if (ParentInboxFolderObj != null)
                        {
                            //Set special folder for ADXOlFormsCollectionItem    
                            //like "Personal Forlers\Inbox"
                            adxOlFormsManager1.LockUpdates();
                            InboxItem.FolderName = ParentInboxFolderObj.Name + @"\" + InboxFolderObj.Name;
                            adxOlFormsManager1.UnlockUpdates();
                        }
                    }

                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                if (ParentInboxFolderObj != null)
                {
                    Marshal.ReleaseComObject(ParentInboxFolderObj);
                }
                if (InboxFolderObj != null)
                {
                    Marshal.ReleaseComObject(InboxFolderObj);
                }
                if (NameSpaceObj != null)
                {
                    Marshal.ReleaseComObject(NameSpaceObj);
                }
            }
            #endregion

        }

    }
}

