#pragma once
 
#include <memory>
 
class CLoader
{
public:
    static CLoader *TheInstance();
    HRESULT CreateInstance(LPCWSTR szRuntimeVersion, LPCWSTR szAssemblyName, LPCWSTR szClassName, const IID &riid, void ** ppvObject);
    HRESULT RegisterADXProject(LPCWSTR szRuntimeVersion, LPCWSTR szAssemblyName, LPCWSTR szClassName, BOOL mode);
 
protected:
    CLoader(void);
    virtual ~CLoader(void);
 
    HRESULT LoadCLR(LPCWSTR szRuntimeVersion);
    HRESULT CreateLocalAppDomain();
 
private:
    friend std::auto_ptr<CLoader>;
    static std::auto_ptr<CLoader> m_pInstance;
 
    ICorRuntimeHost *m_pHost;
    mscorlib::_AppDomain *m_pLocalDomain;
};

